package hu.kozadat.oaiaggregator.service.oaipmh;

import hu.kozadat.oaicentral.xml.oai_pmh_v2_0.OAIPMHerrorType;
import hu.kozadat.oaicentral.xml.oai_pmh_v2_0.OAIPMHerrorcodeType;
import org.springframework.stereotype.Component;

/**
 * Created by tnagy on 2015.10.14..
 */
@Component
public class ErrorFactory {

    public OAIPMHerrorType createError(OAIPMHerrorcodeType errorCode, String errorMessage) {
        OAIPMHerrorType error = new OAIPMHerrorType();
        error.setCode(errorCode);
        error.setValue(errorMessage);
        return error;
    }

    public OAIPMHerrorType badVerb() {
        String errorMessage = "Bad verb.";
        return createError(OAIPMHerrorcodeType.BAD_VERB, errorMessage);
    }

    public OAIPMHerrorType noMetadataFormats() {
        String errorMessage = "No MetadataFormats.";
        return createError(OAIPMHerrorcodeType.NO_METADATA_FORMATS, errorMessage);
    }

    public OAIPMHerrorType idDoesNotExist(String oaiIdentifier) {
        String errorMessage = "Id does not exist: " + oaiIdentifier;
        return createError(OAIPMHerrorcodeType.ID_DOES_NOT_EXIST, errorMessage);
    }

    public OAIPMHerrorType noSetHierarchy() {
        String errorMessage = "No Set Hierarchy.";
        return createError(OAIPMHerrorcodeType.NO_SET_HIERARCHY, errorMessage);
    }

    public OAIPMHerrorType badArgument(String errorMessage) {
        return createError(OAIPMHerrorcodeType.BAD_ARGUMENT, errorMessage);
    }

    public OAIPMHerrorType cannotDisseminateFormat(String metadataPrefix) {
        String errorMessage = "MetadataPrefix not recognized: " + metadataPrefix;
        return createError(OAIPMHerrorcodeType.CANNOT_DISSEMINATE_FORMAT, errorMessage);
    }

    public OAIPMHerrorType noRecordsMatch() {
        String errorMessage = "No records match.";
        return createError(OAIPMHerrorcodeType.NO_RECORDS_MATCH, errorMessage);
    }

    public OAIPMHerrorType badResumptionToken() {
        String errorMessage = "Bad Resumption Token.";
        return createError(OAIPMHerrorcodeType.BAD_RESUMPTION_TOKEN, errorMessage);
    }

    public OAIPMHerrorType unexpectedError(Exception e) {
        OAIPMHerrorType unexpectedError = new OAIPMHerrorType();
        unexpectedError.setCode(null);
        unexpectedError.setValue(e.getMessage());
        return unexpectedError;
    }

}
