package hu.kozadat.oaiaggregator.service.oaipmh;

/**
 * Created by tnagy on 2015.10.14..
 */
public class Request {

    public static final String VERB_IDENTIFY = "Identify";
    public static final String VERB_LIST_METADATA_FORMATS = "ListMetadataFormats";
    public static final String VERB_LIST_SETS = "ListSets";
    public static final String VERB_LIST_IDENTIFIERS = "ListIdentifiers";
    public static final String VERB_LIST_RECORDS = "ListRecords";
    public static final String VERB_GET_RECORD = "GetRecord";

    private String requestURL;
    private String verb;
    private String metadataPrefix;
    private String resumptionToken;
    private String identifier;
    private String from;
    private String until;
    private String set;

    public Request(String requestURL, String verb, String metadataPrefix, String resumptionToken, String identifier, String from, String until, String set) {
        this.requestURL = requestURL;
        this.verb = verb;
        this.metadataPrefix = metadataPrefix;
        this.resumptionToken = resumptionToken;
        this.identifier = identifier;
        this.from = from;
        this.until = until;
        this.set = set;
    }

    public String getRequestURL() {
        return requestURL;
    }

    public void setRequestURL(String requestURL) {
        this.requestURL = requestURL;
    }

    public String getVerb() {
        return verb;
    }

    public void setVerb(String verb) {
        this.verb = verb;
    }

    public String getMetadataPrefix() {
        return metadataPrefix;
    }

    public void setMetadataPrefix(String metadataPrefix) {
        this.metadataPrefix = metadataPrefix;
    }

    public String getResumptionToken() {
        return resumptionToken;
    }

    public void setResumptionToken(String resumptionToken) {
        this.resumptionToken = resumptionToken;
    }

    public String getIdentifier() {
        return identifier;
    }

    public void setIdentifier(String identifier) {
        this.identifier = identifier;
    }

    public String getFrom() {
        return from;
    }

    public void setFrom(String from) {
        this.from = from;
    }

    public String getUntil() {
        return until;
    }

    public void setUntil(String until) {
        this.until = until;
    }

    public String getSet() {
        return set;
    }

    public void setSet(String set) {
        this.set = set;
    }

    public boolean isIdentify() {
        return VERB_IDENTIFY.equals(verb);
    }

    public boolean isListMetadataFormats() {
        return VERB_LIST_METADATA_FORMATS.equals(verb);
    }

    public boolean isListSets() {
        return VERB_LIST_SETS.equals(verb);
    }

    public boolean isListIdentifiers() {
        return VERB_LIST_IDENTIFIERS.equals(verb);
    }

    public boolean isListRecords() {
        return VERB_LIST_RECORDS.equals(verb);
    }

    public boolean isGetRecord() {
        return VERB_GET_RECORD.equals(verb);
    }

}
